#include <kihon.h>
#include <kanade.h>
#include <kyotsu.h>

#define DMA	(char*)0x0700

typedef enum {
	modeDRAWTITLE    = 0,
	modeTITLE        = 1,
	modeDRAWGAME     = 2,
	modeGAME         = 3,
	modeENDING       = 4,
} emode;

char  init;
int  score;
emode mode;

typedef struct charastatus {
	unsigned char x,y;
	unsigned char visible;
	unsigned char mode;
	unsigned char col;
} status;

void ClearScreen()
{
	unsigned char i,first,pos[2];

	SetChannel(0x00);

	first = 1;
	for (i = 0; i < 64; i++)
	{
		SetSprite(first,0,240,0,0);
		first = 0;
	}

	for (i = 0; i < 30; i++)
	{
		GetBackgroundAddress(0, 0, i, pos);
		FillBackground(*(pos + 0),*(pos + 1),0,32);
	}
}

void DrawTitle(char first)
{
	unsigned char ttl[24];
	unsigned char i,j,pos;

	if (! first) { SetPPU(0x08,0x06); }

	ClearScreen();
	FillAttribute(0x23,0xc0,0,64);

	pos = 0xa0;
	for (i = 0; i < 4; i++)
	{
		for (j = 0; j < 24; j++)
		{
			ttl[j] = pos;
			pos++;
		}
		SetBackground(0x21,0x04 + 0x20 * i,ttl,24);
	}

	SetBackground(0x22,0x4c,"RACE GAME",9);
	//SetBackground(0x23,0x43,"www37.atwiki.jp/kikakubu4/",26);
	SetScroll( 0, 0 );
	SetPPU(0x08,0x1e);

	init = 0;
	mode = modeTITLE;
}

void DrawCar(char first,char x, char y, char col,char out)
{
	SetDMA( DMA,first,x  ,y  ,0x11 + out * 2,col);
	SetDMA( DMA,0    ,x+8,y  ,0x12 + out * 2,col);
	SetDMA( DMA,0    ,x  ,y+8,0x21 + out * 2,col);
	SetDMA( DMA,0    ,x+8,y+8,0x22 + out * 2,col);
	//SetSprite(first,x  ,y  ,0x11 + out * 2,col);
	//SetSprite(0    ,x+8,y  ,0x12 + out * 2,col);
	//SetSprite(0    ,x  ,y+8,0x21 + out * 2,col);
	//SetSprite(0    ,x+8,y+8,0x22 + out * 2,col);
}

void DrawString(char x,char y,char *str,char len)
{
	char i;
	for (i=0;i<len;i++) {
		//SetSprite(0, x + i * 8, y, *(str + i), 1 );
		SetDMA( DMA, 0, x + i * 8 , y, *(str + i), 1 );
	}
}

void DrawScore(char x, char y, int scr)
{
	int wrk;
	char str[5];
	signed char i;

	for (i=4;i>=0;i--) {
		wrk = scr % 10;
		str[i] = 0x30 + wrk;
		scr /= 10;
	}
	str[4] = 0x30;
	DrawString(x,y,str,5);
}

void DrawGame()
{
	const char bg[] = { 2,2,2,2,2,2,3,2,2,2,2,2 };
	unsigned char pos[2],i;

	SetPPU(0x08,0x06);
	ClearScreen();

	FillAttribute(0x23,0xc0,0x55,64);

	for (i = 0; i < 30; i++)
	{
		GetBackgroundAddress(0, 0, i, pos);
		FillBackground(*(pos + 0),*(pos + 1),1,10);

		GetBackgroundAddress(0,10, i, pos);
		SetBackground(*(pos + 0),*(pos + 1),(char *)bg,12);

		GetBackgroundAddress(0,22, i, pos);
		FillBackground(*(pos + 0),*(pos + 1),1,10);
	}
	SetScroll( 0, 0 );
	SetPPU(0x08,0x1e);

	mode = modeGAME;
}

void Game()
{
	static status car[4];
	static char count, check;
	static char speed, scroll, pause;
	static char wx, wy, add;
	static signed int x, y;
	static int hiscore=0;
	char i,wrk,chk=0;

	if (init == 0) {
		count = 0;
		check = 0;
		speed = 0;
		scroll = 0;
		pause = 0;
		wx = 0;
		wy = 0;
		add = 0;
		x = 0;
		y = 0;
		score = 0;
		car->x = 125;
		car->y = 200;
		car->col  = 1;
		car->mode = 1;
		car->visible = 1;
		for (i=1;i<4;i++) {
			(car + i)->visible = 0;
		}

		SetChannel(0x00);
		SetTriangle(0xff);
		SetChannel(0x04);

		init = 1;
	}

	if (car->mode) {
		DrawCar(1,wx,wy,car->col,0);
	} else {
		DrawCar(1,wx,wy,3,1);
	}
	for (i=1;i<4;i++) {
		if ((car + i)->visible) {
			DrawCar(0,(car + i)->x,(car + i)->y,(car + i)->col,0);
		} else {
			DrawCar(0,0,240,0,0);
		}
	}

	DrawScore(198,42,hiscore);
	DrawScore(198,52,score  );

	if ( ButtonPush(0, BTN_START ) ) {
		pause ^= 1;
		if (pause) {
			SetChannel(0x00);
		} else {
			SetChannel(0x04);
		}
	}

	if ( pause ) {
		DrawString(198 ,92,"PAUSE", 5);
		return;
	} else {
		DrawString(198 ,92,"     ", 5);
	}

	if ( speed > 100 ) {
		add = 2;
		if (count % 20 == 0 && car->mode) {
			score += 1;
			if (hiscore < score) { hiscore = score; }
		}
	} else if ( speed > 0 ) {
		add = 1;
	} else {
		add = 0;
	}

	if (! car->mode ) {
		if (speed < 2) { SetChannel(0x04); }
	} else if (speed > 2) {
		PlayTriangle((300 - speed) * 5,0x1f);
	}

	if (car->mode) {
		if ( ButtonDown(0, BTN_UP   ) && y     > -120 ) { y -= add; }
		if ( ButtonDown(0, BTN_DOWN ) && y     <   30 ) { y += add; }
		if ( ButtonDown(0, BTN_LEFT ) && x     > -135 ) { x -= add; }
		if ( ButtonDown(0, BTN_RIGHT) && x     <  105 ) { x += add; }
		if ( ButtonDown(0, BTN_A    ) && speed <  200 ) { speed++;  } else if (speed > 0) { speed--; }
		if ( ButtonDown(0, BTN_B    ) && speed >    2 ) { speed-=2; }
	} else if ( speed >= 2 ) {
		speed-=2;
	} else if (score <= 999) {
		car->mode=1;
		score = 0;
	} else {
		init = 0;
		mode = modeENDING;
		return;
	}

	//x:80-160 , y:160-210

	wx = car->x + x / 3;
	wy = car->y + y / 3;

	count++;
	check++;

	for (i=1;i<4;i++) {
		if ((car + i)->visible && (car + i)->y > 240 && (car + i)->y < 247) {
			(car + i)->visible = 0;
		} else if ((car + i)->visible && speed <= 100) {
			(car + i)->y-=(100 - speed) / 20;
		} else if ((car + i)->visible == 0) {
			if (count % 50 == 0 && count > 0 && chk == 0) {
				(car + i)->mode = check % 6 + 1;
				(car + i)->col = check % 4;
				if ((car + i)->mode == 6) {
					(car + i)->x = wx;
				} else {
					(car + i)->x = 100 + count / 5;
				}
				(car + i)->y = 247;
				(car + i)->visible = 1;
				chk = 1;
			}
		} else {
			if ((car + i)->mode == 1) {
				(car + i)->x+=count % 2;
				(car + i)->y+=3;
				if ((car + i)->x >= 160) { (car + i)->mode = 2; }
			} else if ((car + i)->mode == 2) {
				(car + i)->x-=count % 2;
				(car + i)->y+=3;
				if ((car + i)->x <=  80) { (car + i)->mode = 1; }
			} else if ((car + i)->mode == 3) {
				(car + i)->y+=5;
			} else if ((car + i)->mode == 4) {
				(car + i)->x+=1;
				(car + i)->y+=3;
				if ((car + i)->x >= 160) { (car + i)->mode = 5; }
			} else if ((car + i)->mode == 5) {
				(car + i)->x-=1;
				(car + i)->y+=3;
				if ((car + i)->x <=  80) { (car + i)->mode = 4; }
			} else if ((car + i)->mode == 6) {
				if (wy - 50 < (car + i)->y && (car + i)->y < 247) {
					wrk = 1;
				} else {
					wrk = 0;
				}
				if (wx - 2 > (car + i)->x) {
					(car + i)->x+= 2;
					 if (wrk) { (car + i)->mode = 7; }
				} else if (wx + 2 < (car + i)->x) {
					(car + i)->x-= 2;
					 if (wrk) { (car + i)->mode = 8; }
				} else if (wrk) {
					(car + i)->mode = 9;
				}
				(car + i)->y+=1;
			} else if ((car + i)->mode == 7) {
				if ((car + i)->x < 160) { (car + i)->x+=count % 2; }
				(car + i)->y+=1;
			} else if ((car + i)->mode == 8) {
				if ((car + i)->x >  80) { (car + i)->x-=count % 2; }
				(car + i)->y+=1;
			} else if ((car + i)->mode == 9) {
				(car + i)->y+=1;
			}
		}
		//if ((car + i)->visible) {
		//	DrawCar((car + i)->x,(car + i)->y,(car + i)->col,0);
		//}
	}
	if (count == 200) { count = 255; }
	scroll -= speed / 40;
	if (scroll >= 240) { scroll = 239; }
	SetScroll( 0, scroll );

	if (car->mode) {
		for (i=1;i<4;i++) {
			if (HitBox(wx+2,wy+2,wx+14,wy+17,(car + i)->x+2,(car + i)->y+2,(car + i)->x+14,(car + i)->y+17)) {
				car->mode=0;
				SetChannel(0x00);
				SetNoise(0x0c);
				SetChannel(0x08);
				PlayNoise(0x0e,22);
				break;
			}
		}
	}

	VBlank();
	SendDMA(7);

}

void Ending()
{
	char i,j,pos[2],bg[8];

	if (init == 0) {
		SetPPU(0x08,0x06);
		ClearScreen();

		FillAttribute(0x23,0xc0,0xff,64);
		for (i = 0; i < 4; i++)
		{
			for (j = 0; j < 8; j++) { bg[j] = 0x80 + i * 8 + j; }
			GetBackgroundAddress(0, 12, 10 + i, pos);
			SetBackground(*(pos + 0), *(pos + 1), bg, 8);
		}
		GetBackgroundAddress(0, 10, 15, pos);
		SetBackground(*(pos + 0), *(pos + 1),"SCORE", 5);
		DrawScore( 138,119,score);

		SetScroll( 0, 0 );
		SetPPU(0x08,0x1e);

		init = 1;
	}

	if ( ButtonPush(0, BTN_START ) || ButtonPush(0, BTN_A ) || ButtonDown(0, BTN_B) ) {
		mode = modeDRAWTITLE;
	}
}

void Title()
{
	char start=0;

	if ( ButtonPush(0, BTN_START ) || ButtonPush(0, BTN_A ) ) {
		start = 1;
	}
	if (start) {
		init = 0;
		mode = modeDRAWGAME;
	}
}

// C
void NesMain()
{

	const char palettebg[] = { 0x0f, 0x11, 0x21, 0x30, 0x20, 0x00, 0x20, 0x11,
				   0x0f, 0x00, 0x30, 0x36, 0x0f, 0x06, 0x15, 0x30 };
	const char palettesp[] = { 0x0f, 0x11, 0x21, 0x30, 0x11, 0x30, 0x26, 0x1f,
				   0x11, 0x21, 0x26, 0x1f, 0x11, 0x26, 0x15, 0x1f };
	VBlank();
	InitPPU();

	SetPalette((char *)palettebg,0);
	SetPalette((char *)palettesp,1);

	DrawTitle(1);

	SetPPU(0x08,0x1e);
	mode = modeTITLE;

	while (1) {
		//VBlank();
		CheckPad();
		if ( ButtonDown(0, BTN_START) && ButtonPush(0, BTN_SELECT) ) {
			mode = modeDRAWTITLE;
		}
		switch (mode) {
		case modeDRAWTITLE:
			DrawTitle(0);
			break;
		case modeTITLE:
			Title();
			break;
		case modeDRAWGAME:
			DrawGame();
			break;
		case modeGAME:
			Game();
			break;
		case modeENDING:
			Ending();
			break;
		}
	}
}

//NMI荞
void NMIProc(void){}
